Index: roard/streams.c
===================================================================
--- roard/streams.c	(revision 6052)
+++ roard/streams.c	(revision 0)
@@ -1999,216 +354,72 @@
     continue;
    }
-   if ( streams_fill_mixbuffer2(i, info) == -1 ) {
+   if ( streams_fill_mixbuffer(i, info) == -1 ) {
     ROAR_ERR("streams_get_mixbuffer(*): Can not fill output buffer for stream %i, this should not happen", i);
     continue;
    }
 
-//   printf("D: bufs[have=%i] = %p\n", have, bufs[have]);
-
    ROAR_DBG("streams_get_mixbuffers(*):  bufs[have] = %p", bufs[have]);
    ROAR_DBG("streams_get_mixbuffers(*): *bufs[have] = 0x%08x...", *(uint32_t*)bufs[have]);
 
-   if ( !streams_get_flag(i, ROAR_FLAG_MUTE) )
-    have++; // we have a new stream!
+   have++; // we have a new stream!
   }
  }
 
  bufs[have] = NULL;
- //printf("D: bufs[have=%i] = %p\n", have, bufs[have]);
 
  ROAR_DBG("streams_get_mixbuffers(*): have = %i", have);
 
  *bufferlist = bufs;
- return have;
-}
-
-
-int stream_add_buffer  (int id, struct roar_buffer ** buf) {
+ return 0;
+}
+
+
+int stream_add_buffer  (int id, struct roar_buffer * buf) {
  ROAR_DBG("stream_add_buffer(id=%i, buf=%p) = ?", id, buf);
 
- _CHECK_SID(id);
+ if ( g_streams[id] == NULL )
+  return -1;
 
  if ( g_streams[id]->buffer == NULL ) {
-  g_streams[id]->buffer = *buf;
+  g_streams[id]->buffer = buf;
+  ROAR_DBG("stream_add_buffer(id=%i, buf=%p) = 0", id, buf);
+  return 0;
+ }
+
+ ROAR_DBG("stream_add_buffer(id=%i, buf=%p) = ?", id, buf);
+ return roar_buffer_add(g_streams[id]->buffer, buf);
+}
+
+int stream_shift_buffer   (int id, struct roar_buffer ** buf) {
+ struct roar_buffer * next;
+
+ if ( g_streams[id] == NULL )
+  return -1;
+
+ if ( g_streams[id]->buffer == NULL ) {
   *buf = NULL;
-  ROAR_DBG("stream_add_buffer(id=%i, buf=%p) = 0", id, buf);
-  return 0;
- }
-
- ROAR_DBG("stream_add_buffer(id=%i, buf=%p) = ?", id, buf);
- return roar_buffer_moveinto(g_streams[id]->buffer, buf);
-}
-
-int stream_shift_out_buffer   (int id, void * data, size_t * len) {
- _CHECK_SID(id);
-
- if ( g_streams[id]->buffer == NULL )
-  return -1;
-
- return roar_buffer_shift_out(&(g_streams[id]->buffer), data, len);
-}
-
-int stream_outputbuffer_request(int id, struct roar_buffer ** buf, size_t len) {
- register struct roar_stream_server *  ss;
- size_t buflen;
- void * bufdata;
- int ret;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- if ( buf != NULL ) /* just be be sure */
-  *buf = NULL;
-
- if ( ss->outputbuffer != NULL ) {
-  if ( roar_buffer_get_len(ss->outputbuffer, &buflen) == 0 ) {
-   if ( buflen == len ) {
-    if ( buf != NULL )
-     *buf = ss->outputbuffer;
-    return 0;
-   } else if ( buflen > len ) {
-    if ( roar_buffer_set_len(ss->outputbuffer, len) == 0 ) {
-     if ( buf != NULL )
-      *buf = ss->outputbuffer;
-     return 0;
-    }
-   }
-  }
-
-  // if the buffer is not suitable:
-
-  ret = roar_buffer_free(ss->outputbuffer);
-  ss->outputbuffer = NULL;
-  if ( ret == -1 )
-   return ret;
- }
-
- if ( roar_buffer_new(&(ss->outputbuffer), len) == -1 )
-  return -1;
-
- if ( roar_buffer_get_data(ss->outputbuffer, &bufdata) == -1 ) {
-  roar_buffer_free(ss->outputbuffer);
-  ss->outputbuffer = NULL;
-  return -1;
- }
-
- memset(bufdata, 0, len);
-
- if ( buf != NULL )
-  *buf = ss->outputbuffer;
-
- return 0;
-}
-
-int stream_outputbuffer_destroy(int id) {
- int ret;
- register struct roar_stream_server *  ss;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- if ( ss->outputbuffer != NULL ) {
-  ret = roar_buffer_free(ss->outputbuffer);
-  ss->outputbuffer = NULL;
-  return ret;
- }
-
- return 0;
-}
-
-int stream_prethru_add(int id, struct roar_buffer ** buf) {
- register struct roar_stream_server *  ss;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- if ( ss->prethru == NULL ) {
-  ss->prethru = *buf;
-  *buf = NULL;
-  return 0;
- }
-
- if ( roar_buffer_moveinto(ss->prethru, buf) == -1 ) {
-  return -1;
- }
-
- return 0;
-}
-
-int stream_prethru_add_data(int id, void ** buf, size_t len) {
- struct roar_buffer * buffer;
-
- _CHECK_SID(id);
-
- if ( roar_buffer_new_data(&buffer, len, buf) == -1 )
-  return -1;
-
- if ( stream_prethru_add(id, &buffer) == -1 ) {
-  roar_buffer_free(buffer);
-  return -1;
- }
-
- return 0;
-}
-
-int stream_prethru_destroy(int id) {
- int ret;
- register struct roar_stream_server *  ss;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- if ( ss->prethru != NULL ) {
-  ret = roar_buffer_free(ss->prethru);
-  ss->prethru = NULL;
-  return ret;
- }
-
- return 0;
-}
-
-int stream_prethru_send(int dst, int src) {
- struct roar_stream_server *  dst_ss, * src_ss;
- struct roar_buffer * bufbuf;
- void * bufdata;
- size_t buflen;
-
- ROAR_DBG("stream_prethru_send(dst=%i, src=%i) = ?", dst, src);
-
- _CHECK_SID(dst);
- _CHECK_SID(src);
-
- if ( (dst_ss = g_streams[dst]) == NULL )
-  return -1;
-
- if ( (src_ss = g_streams[src]) == NULL )
-  return -1;
-
- bufbuf = src_ss->prethru;
-
- ROAR_DBG("stream_prethru_send(dst=%i, src=%i): prethru buffer at %p", dst, src, bufbuf);
-
- roar_buffer_foreach(bufbuf) {
-  ROAR_DBG("stream_prethru_send(dst=%i, src=%i): looping with buffer at %p", dst, src, bufbuf);
-
-  if ( roar_buffer_get_data(bufbuf, &bufdata) == -1 )
-   return -1;
-
-  if ( roar_buffer_get_len(bufbuf, &buflen) == -1 )
-   return -1;
-
-  if ( stream_vio_s_write(dst_ss, bufdata, buflen) != buflen )
-   return -1;
- }
-
- ROAR_DBG("stream_prethru_send(dst=%i, src=%i) = 0", dst, src);
+  return 0;
+ }
+
+ roar_buffer_get_next(g_streams[id]->buffer, &next);
+
+ *buf                  = g_streams[id]->buffer;
+ g_streams[id]->buffer = next;
+
+ return 0;
+}
+int stream_unshift_buffer (int id, struct roar_buffer *  buf) {
+ if ( g_streams[id] == NULL )
+  return -1;
+
+ if ( g_streams[id]->buffer == NULL ) {
+  g_streams[id]->buffer = buf;
+  return 0;
+ }
+
+ roar_buffer_add(buf, g_streams[id]->buffer);
+
+ g_streams[id]->buffer = buf;
+
  return 0;
 }
@@ -2216,93 +427,29 @@
 int streams_check  (int id) {
  int fh;
- ssize_t req, realreq, done;
+ size_t req;
  struct roar_stream        *   s;
  struct roar_stream_server *  ss;
  struct roar_buffer        *   b;
- void                      * buf;
-// char                        tmp;
-
- _CHECK_SID(id);
+ char                      * buf;
+
+ if ( g_streams[id] == NULL )
+  return -1;
 
  ROAR_DBG("streams_check(id=%i) = ?", id);
 
- s = ROAR_STREAM(ss = g_streams[id]);
+ s = (struct roar_stream *) (ss = g_streams[id]);
 
  if ( (fh = s->fh) == -1 )
   return 0;
 
- if ( streams_get_flag(id, ROAR_FLAG_PAUSE) )
-  return 0;
-
- switch (s->dir) {
-  case ROAR_DIR_LIGHT_IN:
-#ifndef ROAR_WITHOUT_DCOMP_LIGHT
-    return light_check_stream(id);
-#else
-    streams_delete(id);
-    return -1;
-#endif
-   break;
-  case ROAR_DIR_MIDI_IN:
-#ifndef ROAR_WITHOUT_DCOMP_MIDI
-    return midi_check_stream(id);
-#else
-    streams_delete(id);
-    return -1;
-#endif
-   break;
-  case ROAR_DIR_RAW_IN:
-#ifndef ROAR_WITHOUT_DCOMP_RAW
-    return raw_check_stream(id);
-#else
-    streams_delete(id);
-    return -1;
-#endif
-   break;
-  case ROAR_DIR_RDTCS_IN:
-#ifndef ROAR_WITHOUT_DCOMP_RDTCS
-    return rdtcs_check_stream(id);
-#else
-    streams_delete(id);
-    return -1;
-#endif
-   break;
-  case ROAR_DIR_PLAY:
-  case ROAR_DIR_BIDIR:
-  case ROAR_DIR_RECPLAY:
-   break;
-  case ROAR_DIR_OUTPUT:
-    if ( !streams_get_flag(id, ROAR_FLAG_RECSOURCE) )
-     return 0;
-   break;
-  default:
-/*
-    ROAR_WARN("streams_check(id=%i): Read event on non input stream of type/dir %s", id, roar_dir2str(s->dir));
-    errno = 0;
-    req = stream_vio_s_read(ss, &tmp, 1);
-    ROAR_DBG("streams_check(id=%i): stream_vio_s_read(ss, &tmp, 1) = %li // errno=%s(%i)", id, req, strerror(errno), errno);
-    if ( req == 1 ) {
-     ROAR_ERR("streams_check(id=%i): Client violates protocol, got one byte of data on output stream, kicking stream");
-     streams_delete(id);
-     return -1;
-    }
-*/
-    return 0;
-   break;
- }
+ if ( s->dir != ROAR_DIR_PLAY )
+  return 0;
 
  ROAR_DBG("streams_check(id=%i): fh = %i", id, fh);
 
-/*
- ROAR_DBG("streams_check(id=%i): ROAR_OUTPUT_BUFFER_SAMPLES=%i, s->info.channels=%i, s->info.bits=%i, s->info.rat=%i, g_sa->rate=%i", id, ROAR_OUTPUT_BUFFER_SAMPLES, s->info.channels, s->info.bits, s->info.rate, g_sa->rate);
-*/
-
- req  = ROAR_OUTPUT_CALC_OUTBUFSIZE(&(s->info)); // optimal size
-// req  = ROAR_OUTPUT_BUFFER_SAMPLES * s->info.channels * (s->info.bits / 8) * ((float)s->info.rate/g_sa->rate);
+ req  = ROAR_OUTPUT_BUFFER_SAMPLES * s->info.channels * s->info.bits / 8; // optimal size
  req += ss->need_extra; // bytes left we sould get....
 
- ROAR_DBG("streams_check(id=%i): asking for %i bytes", id, req);
-
- if ( roar_buffer_new_data(&b, req, &buf) == -1 ) {
+ if ( roar_buffer_new(&b, req) == -1 ) {
   ROAR_ERR("streams_check(*): Can not alloc buffer space!");
   ROAR_DBG("streams_check(*) = -1");
@@ -2310,52 +457,23 @@
  }
 
+ roar_buffer_get_data(b, (void **)&buf);
+
  ROAR_DBG("streams_check(id=%i): buffer is up and ready ;)", id);
- ROAR_DBG("streams_check(id=%i): asking for %i bytes", id, req);
-
- if ( ss->codecfilter == -1 ) {
-  realreq = req;
-/*
-  req = read(fh, buf, req);
-  if ( req < realreq ) { // we can do this as the stream is in nonblocking mode!
-   if ( (realreq = read(fh, buf+req, realreq-req)) > 0 )
-    req += realreq;
-  }
-*/
-  done = 0;
-  while (req > 0 && done != realreq) {
-   if ( (req = stream_vio_s_read(ss, buf+done, realreq-done)) > 0 )
-    done += req;
-  }
-  req = done;
-
- } else {
-  req = codecfilter_read(ss->codecfilter_inst, ss->codecfilter, buf, req);
- }
-
- if ( req > 0 ) {
+
+ if ( (req = read(fh, buf, req)) > 0 ) {
   ROAR_DBG("streams_check(id=%i): got %i bytes", id, req);
 
-  if ( roar_buffer_set_len(b, req) != -1 ) {
-   if ( stream_add_buffer(id, &b) != -1 )
-    return 0;
-
-   ROAR_ERR("streams_check(id=%i): something is wrong, could not add buffer to stream!", id);
-  } else {
-   ROAR_ERR("streams_check(id=%i): something is wrong, could not set size of buffer!", id);
-  }
-
+  roar_buffer_set_len(b, req);
+
+  if ( stream_add_buffer(id, b) != -1 )
+   return 0;
+
+  ROAR_ERR("streams_check(id=%i): something is wrong, could not add buffer to stream!", id);
   roar_buffer_free(b);
  } else {
-  ROAR_DBG("streams_check(id=%i): read() = %i // errno: %s", id, req, strerror(errno));
-#ifdef ROAR_HAVE_LIBVORBISFILE
-  if ( errno != EAGAIN && errno != ESPIPE ) { // libvorbis file trys to seek a bit ofen :)
-#else
-  if ( errno != EAGAIN ) {
-#endif
-   ROAR_DBG("streams_check(id=%i): EOF!", id);
-   streams_delete(id);
-   ROAR_DBG("streams_check(id=%i) = 0", id);
-  }
+  ROAR_DBG("streams_check(id=%i): EOF!", id);
   roar_buffer_free(b);
+  streams_delete(id);
+  ROAR_DBG("streams_check(id=%i) = 0", id);
   return 0;
  }
@@ -2367,231 +485,26 @@
 
 
-#define _return(x) return (x)
 int streams_send_mon   (int id) {
-// int fh;
+ int fh;
  struct roar_stream        *   s;
  struct roar_stream_server *  ss;
- struct roar_buffer        *  bufbuf = NULL;
- struct roar_remove_state     removalstate;
- void  * ip              = g_output_buffer;
- void  * obuf;
- int     olen;
- int     is_the_same     = 1;
- int     is_vol_eq       = 1;
- int     is_muted;
- int     antiecho        = 0;
- ssize_t ret;
-
- _CHECK_SID(id);
+
+ if ( g_streams[id] == NULL )
+  return -1;
 
  ROAR_DBG("streams_send_mon(id=%i) = ?", id);
 
- s = ROAR_STREAM((ss = g_streams[id]));
-
-/*
+ s = (struct roar_stream *) (ss = g_streams[id]);
+
  if ( (fh = s->fh) == -1 )
   return 0;
-*/
-
- if ( !ss->ready )
-  return 0;
-
- if ( g_config->jumbo_mtu )
-  roar_vio_sync(ss->viop);
-
- if ( streams_get_flag(id, ROAR_FLAG_PAUSE) )
-  return 0;
-
- switch (s->dir) {
-  case ROAR_DIR_LIGHT_OUT:
-#ifndef ROAR_WITHOUT_DCOMP_LIGHT
-    return light_send_stream(id);
-#else
-    streams_delete(id);
-    return -1;
-#endif
-   break;
-  case ROAR_DIR_MIDI_OUT:
-#ifndef ROAR_WITHOUT_DCOMP_MIDI
-    return midi_send_stream(id);
-#else
-    streams_delete(id);
-    return -1;
-#endif
-   break;
-  case ROAR_DIR_RDTCS_OUT:
-#ifndef ROAR_WITHOUT_DCOMP_RDTCS
-    return rdtcs_send_stream(id);
-#else
-    streams_delete(id);
-    return -1;
-#endif
-   break;
-
-  case ROAR_DIR_COMPLEX_OUT:
-    // send a tick:
-    if ( ss->codecfilter != -1 ) {
-     if ( codecfilter_write(ss->codecfilter_inst, ss->codecfilter, NULL, 0) == 0 )
-      if ( ss->state != ROAR_STREAMSTATE_OLD ) {
-       //ROAR_INFO("streams_send_mon(id=%i): stream state: %s->old", ROAR_DBG_INFO_VERBOSE, id, roar_streamstate2str(ss->state));
-       _streams_change_state(ss, ROAR_STREAMSTATE_OLD, "streams_send_mon");
-      }
-    }
-    return 0;
-   break;
-
-  case ROAR_DIR_OUTPUT:
-    if ( g_standby )
-     return 0;
-  case ROAR_DIR_MONITOR:
-  case ROAR_DIR_BIDIR:
-   break;
-
-  case ROAR_DIR_RECORD:
-  case ROAR_DIR_RECPLAY:
-    ip = g_input_buffer;
-   break;
-  default:
-    return 0;
-   break;
- }
-
-
- ROAR_DBG("streams_send_mon(id=%i): fh = %i", id, s->fh);
-
- if ( s->info.channels != g_sa->channels || s->info.bits  != g_sa->bits ||
-      s->info.rate     != g_sa->rate     || s->info.codec != g_sa->codec  )
-  is_the_same = 0;
-
- is_muted = streams_get_flag(id, ROAR_FLAG_MUTE);
-
- if ( !is_muted && !streams_get_flag(id, ROAR_FLAG_HWMIXER) ) {
-  is_vol_eq = need_vol_change(g_sa->channels, &(ss->mixer)) ? 0 : 1;
- }
-
- if ( streams_get_flag(id, ROAR_FLAG_ANTIECHO) )
-  antiecho = 1;
-
- if ( !is_the_same || !is_vol_eq || antiecho || is_muted ) {
-  olen = ROAR_OUTPUT_CALC_OUTBUFSIZE(&(s->info)); // we hope g_output_buffer_len
-                                                  // is ROAR_OUTPUT_CALC_OUTBUFSIZE(g_sa) here
-  if ( stream_outputbuffer_request(id, &bufbuf, ROAR_OUTPUT_CALC_OUTBUFSIZE_MAX(&(s->info), g_sa)) == -1 )
-   return -1;
-
-  if ( roar_buffer_get_data(bufbuf, &obuf) == -1 ) {
-   _return(-1);
-  }
-
-  ROAR_DBG("streams_send_mon(id=%i): obuf=%p, olen=%i", id, obuf, olen);
- } else {
-  obuf = ip;
-  olen = g_output_buffer_len;
- }
-
- if ( antiecho ) {
-  ROAR_DBG("streams_send_mon(id=%i): antiecho=%i", id, antiecho);
-  if ( roar_remove_init(&removalstate) == -1 ) {
-   _return(-1);
-  }
-
-  ROAR_DBG("streams_send_mon(id=%i): antiecho=%i", id, antiecho);
-  if ( roar_remove_so(obuf, ip, ROAR_OUTPUT_BUFFER_SAMPLES*g_sa->channels, g_sa->bits, &removalstate) == -1 ) {
-   ROAR_DBG("streams_send_mon(id=%i): anti echo failed", id);
-   _return(-1);
-  }
-  ROAR_DBG("streams_send_mon(id=%i): antiecho=%i", id, antiecho);
- }
-
- if ( !is_vol_eq ) {
-  if ( roar_amp_pcm(obuf, g_sa->bits, ip, ROAR_OUTPUT_BUFFER_SAMPLES*g_sa->channels, g_sa->channels, &(ss->mixer)) == -1 ) {
-   _return(-1);
-  }
-
-  ip = obuf;
- }
-
- if ( is_muted ) {
-  memset(obuf, 0, (g_sa->bits*ROAR_OUTPUT_BUFFER_SAMPLES*g_sa->channels)/8);
-  ip = obuf;
- }
-
- streams_ltm_calc(id, &(s->info), ip, (ROAR_OUTPUT_BUFFER_SAMPLES*g_sa->channels*g_sa->bits)/8);
-
- if ( !is_the_same ) {
-  if ( roar_conv(obuf, ip, ROAR_OUTPUT_BUFFER_SAMPLES*g_sa->channels, g_sa, &(s->info)) == -1 ) {
-   _return(-1);
-  }
- }
-
- roar_err_clear_errno();
-
- if ( ss->codecfilter == -1 ) {
-  ROAR_DBG("streams_send_mon(id=%i): not a CF stream", id);
-  if ( s->fh == -1 && ss->vio.inst == NULL ) {
-   ROAR_DBG("streams_send_mon(id=%i) = 0", id);
-   _return(0);
-  }
-
-  ROAR_DBG("streams_send_mon(id=%i) = ?", id);
-
-  if ( (ret = stream_vio_s_write(ss, obuf, olen)) == olen ) {
-   s->pos = ROAR_MATH_OVERFLOW_ADD(s->pos, ROAR_OUTPUT_CALC_OUTBUFSAMP(&(s->info), olen)*s->info.channels);
-   if ( ss->state != ROAR_STREAMSTATE_OLD ) {
-    //ROAR_INFO("streams_send_mon(id=%i): stream state: %s->old", ROAR_DBG_INFO_VERBOSE, id, roar_streamstate2str(ss->state));
-    _streams_change_state(ss, ROAR_STREAMSTATE_OLD, "streams_send_mon");
-   }
-   ROAR_DBG("streams_send_mon(id=%i) = 0", id);
-   _return(0);
-  }
-
-  ROAR_DBG("streams_send_mon(id=%i) = ?", id);
-
-  if ( ret > 0 && roar_err_is_errno_clear() ) {
-   ROAR_WARN("streams_send_mon(id=%i): Overrun in stream: wrote %i of %i bytes, %i bytes missing", id, (int)ret, olen, olen-(int)ret);
-   roar_notify_core_emit_simple(ROAR_OE_STREAM_XRUN, -1, id, ROAR_OT_STREAM, ROAR_XRUN_OVER_POST, -1, NULL, 0);
-   s->pos = ROAR_MATH_OVERFLOW_ADD(s->pos, ROAR_OUTPUT_CALC_OUTBUFSAMP(&(s->info), ret)*s->info.channels);
-   if ( ss->state != ROAR_STREAMSTATE_OLD ) {
-    //ROAR_INFO("streams_send_mon(id=%i): stream state: %s->old", ROAR_DBG_INFO_VERBOSE, id, roar_streamstate2str(ss->state));
-    _streams_change_state(ss, ROAR_STREAMSTATE_OLD, "streams_send_mon");
-   }
-   _return(0);
-  }
- } else {
-  if ( codecfilter_write(ss->codecfilter_inst, ss->codecfilter, obuf, olen)
-            == olen ) {
-   s->pos = ROAR_MATH_OVERFLOW_ADD(s->pos, ROAR_OUTPUT_CALC_OUTBUFSAMP(&(s->info), olen)*s->info.channels);
-   if ( ss->state != ROAR_STREAMSTATE_OLD ) {
-    //ROAR_INFO("streams_send_mon(id=%i): stream state: %s->old", ROAR_DBG_INFO_VERBOSE, id, roar_streamstate2str(ss->state));
-    _streams_change_state(ss, ROAR_STREAMSTATE_OLD, "streams_send_mon");
-   }
-   _return(0);
-  } else { // we cann't retry on codec filetered streams
-   if ( errno != EAGAIN ) {
-    streams_delete(id);
-    _return(-1);
-   }
-  }
- }
-
- if ( errno == EAGAIN ) {
-  // ok, the client blocks for a moment, we try to sleep a bit an retry in the hope not to
-  // make any gapes in any output because of this
-
-#ifdef ROAR_HAVE_USLEEP
-  roar_usleep(100); // 0.1ms
-#endif
-
-  if ( stream_vio_s_write(ss, obuf, olen) == olen ) {
-   s->pos = ROAR_MATH_OVERFLOW_ADD(s->pos, ROAR_OUTPUT_CALC_OUTBUFSAMP(&(s->info), olen)*s->info.channels);
-   if ( ss->state != ROAR_STREAMSTATE_OLD ) {
-    //ROAR_INFO("streams_send_mon(id=%i): stream state: %s->old", ROAR_DBG_INFO_VERBOSE, id, roar_streamstate2str(ss->state));
-    _streams_change_state(ss, ROAR_STREAMSTATE_OLD, "streams_send_mon");
-   }
-   _return(0);
-  } else if ( errno == EAGAIN ) {
-   ROAR_WARN("streams_send_mon(id=%i): Can not send data to client: %s", id, strerror(errno));
-   _return(0);
-  }
- }
+
+ if ( s->dir != ROAR_DIR_MONITOR )
+  return 0;
+
+ ROAR_DBG("streams_send_mon(id=%i): fh = %i", id, fh);
+
+ if ( write(fh, g_output_buffer, g_output_buffer_len) == g_output_buffer_len )
+  return 0;
 
  // ug... error... delete stream!
@@ -2599,43 +512,18 @@
  streams_delete(id);
 
- _return(-1);
-}
-#undef _return
-
-int streams_send_filter_all(void) {
- struct roar_stream_server *  ss;
- int i;
-
- for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-  if ( (ss = g_streams[i]) == NULL )
-   continue;
-
-  if ( ROAR_STREAM(ss)->dir != ROAR_DIR_FILTER )
-   continue;
-
-  if ( !ss->ready )
-   continue;
-
-  if ( ss->state == ROAR_STREAMSTATE_CLOSING )
-   continue;
-
-  streams_send_filter(i);
- }
-
- return 0;
+ return -1;
 }
 
 int streams_send_filter(int id) {
  int fh;
- int have = 0;
- int len;
  struct roar_stream        *   s;
  struct roar_stream_server *  ss;
 
- _CHECK_SID(id);
+ if ( g_streams[id] == NULL )
+  return -1;
 
  ROAR_DBG("streams_send_filter(id=%i) = ?", id);
 
- s = ROAR_STREAM(ss = g_streams[id]);
+ s = (struct roar_stream *) (ss = g_streams[id]);
 
  if ( (fh = s->fh) == -1 )
@@ -2645,19 +533,13 @@
   return 0;
 
- if ( streams_get_flag(id, ROAR_FLAG_PAUSE) )
-  return 0;
-
-
  ROAR_DBG("streams_send_filter(id=%i): fh = %i", id, fh);
 
- if ( stream_vio_s_write(ss, g_output_buffer, g_output_buffer_len) == g_output_buffer_len ) {
-  while ( have < g_output_buffer_len ) {
-   if ( (len = stream_vio_s_read(ss, g_output_buffer+have, g_output_buffer_len-have)) < 1 ) {
-    streams_delete(id);
-    return -1;
-   }
-   have += len;
+ if ( write(fh, g_output_buffer, g_output_buffer_len) == g_output_buffer_len ) {
+  if ( read(fh, g_output_buffer, g_output_buffer_len) == g_output_buffer_len ) {
+   return 0;
+  } else {
+   streams_delete(id);
+   return -1;
   }
-  return 0;
  }
 
@@ -2669,139 +551,3 @@
 }
 
-
-// VIO:
-
-ssize_t stream_vio_read (int stream, void *buf, size_t count) {
- _CHECK_SID(stream);
-
- return stream_vio_s_read(g_streams[stream], buf, count);
-}
-
-ssize_t stream_vio_write(int stream, void *buf, size_t count) {
- _CHECK_SID(stream);
-
- return stream_vio_s_write(g_streams[stream], buf, count);
-}
-
-int     stream_vio_ctl  (int stream, roar_vio_ctl_t cmd,   void * data) {
- _CHECK_SID(stream);
-
- return stream_vio_s_ctl(g_streams[stream], cmd, data);
-}
-
-ssize_t stream_vio_s_read (struct roar_stream_server * stream, void *buf, size_t count) {
- void    * orig_buf = buf;
-  size_t   len      =  0;
- ssize_t   r        = -1;
- int       i;
-
- errno = 0;
-
- if ( stream == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- if ( stream->vio.read == NULL ) {
-  roar_err_set(ROAR_ERROR_NOTSUP);
-  return -1;
- }
-
- while ( (r = roar_vio_read(&(stream->vio), buf, count)) > 0 ) {
-  len   += r;
-  buf   += r;
-  count -= r;
-  if ( count == 0 )
-   break;
- }
-
- if ( len == 0 && r == -1 )
-  return -1;
-
- if ( streams_thru_num ) {
-  for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-   if ( g_streams[i] != NULL && ROAR_STREAM(g_streams[i])->pos_rel_id == ROAR_STREAM(stream)->id ) {
-    if ( ROAR_STREAM(g_streams[i])->dir == ROAR_DIR_THRU ) {
-     if ( g_streams[i]->ready ) {
-      if ( stream_vio_write(i, orig_buf, len) != len )
-       streams_delete(i);
-
-      if ( g_streams[i] != NULL ) {
-       if ( g_streams[i]->state != ROAR_STREAMSTATE_OLD ) {
-        //ROAR_INFO("stream_vio_s_read(*): (stream: %i) stream state: %s->old", ROAR_DBG_INFO_VERBOSE, i, roar_streamstate2str(g_streams[i]->state));
-        _streams_change_state(g_streams[i], ROAR_STREAMSTATE_OLD, "stream_vio_s_read");
-       }
-      }
-     }
-    }
-   }
-  }
- }
-
- return len;
-}
-
-ssize_t stream_vio_s_write(struct roar_stream_server * stream, void *buf, size_t count) {
- int i;
-
- errno = 0;
-
- if ( stream == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
-// ROAR_WARN("stream_vio_s_write(*): writing...");
-
- if ( streams_thru_num ) {
-  for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-   if ( g_streams[i] != NULL && ROAR_STREAM(g_streams[i])->pos_rel_id == ROAR_STREAM(stream)->id ) {
-    if ( ROAR_STREAM(g_streams[i])->dir == ROAR_DIR_THRU ) {
-     if ( g_streams[i]->ready ) {
-      if ( g_streams[i]->state == ROAR_STREAMSTATE_NEW ) {
-       if ( streams_get_flag(i, ROAR_FLAG_PRETHRU) == 1 ) {
-        if ( stream_prethru_send(i, ROAR_STREAM(stream)->id) == -1 ) {
-         streams_delete(i);
-        }
-       }
-      }
-
-      if ( stream_vio_write(i, buf, count) != count ) {
-       streams_delete(i);
-      }
-
-      if ( g_streams[i] != NULL ) {
-       if ( g_streams[i]->state != ROAR_STREAMSTATE_OLD ) {
-        //ROAR_INFO("stream_vio_s_write(*): (stream: %i) stream state: %s->old", ROAR_DBG_INFO_VERBOSE, i, roar_streamstate2str(g_streams[i]->state));
-        _streams_change_state(g_streams[i], ROAR_STREAMSTATE_OLD, "stream_vio_s_write");
-       }
-      }
-     }
-    }
-   }
-  }
- }
-
- if ( g_config->jumbo_mtu ) {
-  if ( stream->viop != &(stream->jumbo) ) {
-   if ( roar_vio_open_jumbo(&(stream->jumbo), &(stream->vio), g_config->jumbo_mtu) != -1 ) {
-    // if that works we continue using the jumbo vio,
-    // in case it didn't we dont, just use normal VIO.
-    stream->viop = &(stream->jumbo);
-   }
-  }
- }
-
- return roar_vio_write(stream->viop, buf, count);
-}
-
-int     stream_vio_s_ctl  (struct roar_stream_server * stream, roar_vio_ctl_t cmd,   void * data) {
- if ( stream == NULL ) {
-  roar_err_set(ROAR_ERROR_FAULT);
-  return -1;
- }
-
- return roar_vio_ctl(stream->viop, cmd, data);
-}
-
 //ll
